1 Star 1 Fork 0

Lucas/gitcommit

加入 Gitee
与超过 1400万 开发者一起发现、参与优秀开源项目,私有仓库也完全免费 :)
免费加入
文件
克隆/下载
commit-msg.sh 2.01 KB
一键复制 编辑 原始数据 按行查看 历史
Lucas 提交于 2024-10-15 15:07 +08:00 . update commit-msg.sh
#!/usr/bin/env bash
#
# An example hook script to check the commit log message.
# Called by "git commit" with one argument, the name of the file
# that has the commit message. The hook should exit with non-zero
# status after issuing an appropriate message if it wants to stop the
# commit. The hook is allowed to edit the commit message file.
#
# To enable this hook, rename this file to "commit-msg".
# Uncomment the below to add a Signed-off-by line to the message.
# Doing this in a hook is a bad idea in general, but the prepare-commit-msg
# hook is more suited to it.
#
# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
# This example catches duplicate Signed-off-by lines.
test "" = "$(grep '^Signed-off-by: ' "$1" |
sort | uniq -c | sed -e '/^[ ]*1[ ]/d')" || {
echo >&2 Duplicate Signed-off-by lines.
exit 1
}
COMMIT_MSG_FILE=$1
msg="$(grep -v '^#' "$COMMIT_MSG_FILE")"
echo -e "\033[33m The commit msg: \033[0m $msg"
#if the msg is merge then skip it
mergePattern='^Merge '
if [[ "$msg" =~ "$mergePattern" ]];then
echo -e "\033[32m skip the merge, commit success! \033[0m"
exit 0
fi
# check the first line of the commit msg
maxlen=200
first_line=$(echo "$msg" | head -n 1)
length=${#first_line}
msg_re="^(feat|fix|docs|style|refactor|test|chore)(\(.+\))?: .{1,200}"
if [[ ! $first_line =~ $msg_re ]];then
echo -e "\033[31m Error: the commit message is irregular \033[0m"
echo -e "\033[31m Error: type must be one of [feat|fix|docs|style|refactor|test|chore]\033[0m"
echo -e "\033[31m eg: feat(user): add the user login \033[0m"
echo -e "\033[31m See: https://confluence.shell.com.cn:9443/pages/viewpage.action?pageId=137398003 for details\033[0m"
exit 1
else
if [ $length -gt $maxlen ];then
echo -e "\033[31m Error: the first line of the commit message exceeds the max length of 200 characters \033[0m"
exit 1
fi
fi
exit 0
Loading...
马建仓 AI 助手
尝试更多
代码解读
代码找茬
代码优化
1
https://gitee.com/lauper/gitcommit.git
git@gitee.com:lauper/gitcommit.git
lauper
gitcommit
gitcommit
master

搜索帮助